import * as cdk from 'aws-cdk-lib';
import * as constructs from 'constructs';
/**
 * Schema for Module Fragment of type FreyrAIM::Spider::CloudFront::MODULE
 *
 * @schema CfnCloudFrontModuleProps
 */
export interface CfnCloudFrontModuleProps {
    /**
     * @schema CfnCloudFrontModuleProps#Parameters
     */
    readonly parameters?: CfnCloudFrontModulePropsParameters;
    /**
     * @schema CfnCloudFrontModuleProps#Resources
     */
    readonly resources?: CfnCloudFrontModulePropsResources;
}
/**
 * Converts an object of type 'CfnCloudFrontModuleProps' to JSON representation.
 */
export declare function toJson_CfnCloudFrontModuleProps(obj: CfnCloudFrontModuleProps | undefined): Record<string, any> | undefined;
/**
 * @schema CfnCloudFrontModulePropsParameters
 */
export interface CfnCloudFrontModulePropsParameters {
    /**
     * The environment name
     *
     * @schema CfnCloudFrontModulePropsParameters#EnvName
     */
    readonly envName?: CfnCloudFrontModulePropsParametersEnvName;
}
/**
 * Converts an object of type 'CfnCloudFrontModulePropsParameters' to JSON representation.
 */
export declare function toJson_CfnCloudFrontModulePropsParameters(obj: CfnCloudFrontModulePropsParameters | undefined): Record<string, any> | undefined;
/**
 * @schema CfnCloudFrontModulePropsResources
 */
export interface CfnCloudFrontModulePropsResources {
    /**
     * @schema CfnCloudFrontModulePropsResources#S3Bucket
     */
    readonly s3Bucket?: CfnCloudFrontModulePropsResourcesS3Bucket;
    /**
     * @schema CfnCloudFrontModulePropsResources#S3BucketPolicy
     */
    readonly s3BucketPolicy?: CfnCloudFrontModulePropsResourcesS3BucketPolicy;
    /**
     * @schema CfnCloudFrontModulePropsResources#SpiderCloudFront
     */
    readonly spiderCloudFront?: CfnCloudFrontModulePropsResourcesSpiderCloudFront;
}
/**
 * Converts an object of type 'CfnCloudFrontModulePropsResources' to JSON representation.
 */
export declare function toJson_CfnCloudFrontModulePropsResources(obj: CfnCloudFrontModulePropsResources | undefined): Record<string, any> | undefined;
/**
 * The environment name
 *
 * @schema CfnCloudFrontModulePropsParametersEnvName
 */
export interface CfnCloudFrontModulePropsParametersEnvName {
    /**
     * @schema CfnCloudFrontModulePropsParametersEnvName#Type
     */
    readonly type: string;
    /**
     * @schema CfnCloudFrontModulePropsParametersEnvName#Description
     */
    readonly description: string;
}
/**
 * Converts an object of type 'CfnCloudFrontModulePropsParametersEnvName' to JSON representation.
 */
export declare function toJson_CfnCloudFrontModulePropsParametersEnvName(obj: CfnCloudFrontModulePropsParametersEnvName | undefined): Record<string, any> | undefined;
/**
 * @schema CfnCloudFrontModulePropsResourcesS3Bucket
 */
export interface CfnCloudFrontModulePropsResourcesS3Bucket {
    /**
     * @schema CfnCloudFrontModulePropsResourcesS3Bucket#Type
     */
    readonly type?: string;
    /**
     * @schema CfnCloudFrontModulePropsResourcesS3Bucket#Properties
     */
    readonly properties?: any;
}
/**
 * Converts an object of type 'CfnCloudFrontModulePropsResourcesS3Bucket' to JSON representation.
 */
export declare function toJson_CfnCloudFrontModulePropsResourcesS3Bucket(obj: CfnCloudFrontModulePropsResourcesS3Bucket | undefined): Record<string, any> | undefined;
/**
 * @schema CfnCloudFrontModulePropsResourcesS3BucketPolicy
 */
export interface CfnCloudFrontModulePropsResourcesS3BucketPolicy {
    /**
     * @schema CfnCloudFrontModulePropsResourcesS3BucketPolicy#Type
     */
    readonly type?: string;
    /**
     * @schema CfnCloudFrontModulePropsResourcesS3BucketPolicy#Properties
     */
    readonly properties?: any;
}
/**
 * Converts an object of type 'CfnCloudFrontModulePropsResourcesS3BucketPolicy' to JSON representation.
 */
export declare function toJson_CfnCloudFrontModulePropsResourcesS3BucketPolicy(obj: CfnCloudFrontModulePropsResourcesS3BucketPolicy | undefined): Record<string, any> | undefined;
/**
 * @schema CfnCloudFrontModulePropsResourcesSpiderCloudFront
 */
export interface CfnCloudFrontModulePropsResourcesSpiderCloudFront {
    /**
     * @schema CfnCloudFrontModulePropsResourcesSpiderCloudFront#Type
     */
    readonly type?: string;
    /**
     * @schema CfnCloudFrontModulePropsResourcesSpiderCloudFront#Properties
     */
    readonly properties?: any;
}
/**
 * Converts an object of type 'CfnCloudFrontModulePropsResourcesSpiderCloudFront' to JSON representation.
 */
export declare function toJson_CfnCloudFrontModulePropsResourcesSpiderCloudFront(obj: CfnCloudFrontModulePropsResourcesSpiderCloudFront | undefined): Record<string, any> | undefined;
/**
 * A CloudFormation `FreyrAIM::Spider::CloudFront::MODULE`
 *
 * @cloudformationResource FreyrAIM::Spider::CloudFront::MODULE
 * @stability external
 * @link http://unknown-url
 */
export declare class CfnCloudFrontModule extends cdk.CfnResource {
    /**
    * The CloudFormation resource type name for this resource class.
    */
    static readonly CFN_RESOURCE_TYPE_NAME = "FreyrAIM::Spider::CloudFront::MODULE";
    /**
     * Resource props.
     */
    readonly props: CfnCloudFrontModuleProps;
    /**
     * Create a new `FreyrAIM::Spider::CloudFront::MODULE`.
     *
     * @param scope - scope in which this resource is defined
     * @param id    - scoped id of the resource
     * @param props - resource properties
     */
    constructor(scope: constructs.Construct, id: string, props: CfnCloudFrontModuleProps);
}
